<?php
//Live Users Pro
//NDWDesign 2007
//http://www.ndwdesign.net


defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

//########## Set up system parameters ##########
//Load the minimum parameters to perform a cache query
global $my, $mosConfig_cachepath;
$settings['basedir'] = $GLOBALS['mosConfig_absolute_path'];
// base directory
$settings['moduledir'] = $settings['basedir'].'/modules/liveuserspro';

//######### Handle caching before doing much else to improve efficiency #######
// Get caching parameters
if($settings['cache'] = intval($params->get('proCache'))) {
	$cacheSettings['lifeTime'] = intval($params->get('cacheLifeTime'));
	$cacheSettings['cacheDir'] = $mosConfig_cachepath .'/';
	//Set up different caches for Guests and registered users
	$cacheSettings['id'] = ($my->id) ? 'lvuCacheRegistered' : 'lvuCacheGuest';
	//initialize cache
	$lvuCache = new Cache_Lite($cacheSettings);
	//check if valid cache exits and return if true
	if($content=$lvuCache->get($cacheSettings['id'])) return $content;
	}
//####################### End of caching code #################################

//Load the rest of the system parameters
$settings['language'] = $mainframe->getCfg( 'lang' );

// base web directory
$settings['lvu_web'] = $GLOBALS['mosConfig_live_site'].'/modules/liveuserspro';

//include class file
require_once($settings['moduledir'].'/liveuserspro.class.php');
$liveUsersPro = new liveUsersPro;

//Load language files
	if (file_exists($settings['moduledir'].'/language/'.$mosConfig_lang.'.php')) {
		include($settings['moduledir'].'/language/'.$mosConfig_lang.'.php');
	} elseif (file_exists($settings['moduledir'].'/language/english.php')) {
		include($settings['moduledir'].'/language/english.php');
	} 
//########## Get module parameters ##########
$settings['header']	        	= trim($params->get( 'header'));
$settings['validate']	        = intval($params->get('validate'));
$settings['nametype']	 		= trim($params->get('nametype','username'));
$settings['nousermsg'] 			= trim($params->get('nousermsg','No user online'));
$settings['userlistlink']		= trim($params->get('userlistlink', 'profile'));
$settings['theme']          	= trim($params->get('theme','simple'));
$settings['modulewidth'] 		= trim($params->get('modulewidth','100%'));
$settings['moduleheight']		= trim($params->get('moduleheight','300px'));
$settings['mousedelay']     	= intval($params->get('mousedelay', 1000 ) );
$settings['scrolling']      	= intval($params->get('scrolling'));
$settings['sponsorlink']    	= intval($params->get('sponsorlink'));
$settings['guestcount']			= intval($params->get('guestcount'));
// Tooltip setup
$settings['showtooltip']		= intval($params->get('showtooltip'));
$settings['tooltipshowguest']	= intval($params->get('tooltipshowguest'));
$settings['tooltipleft']		= intval($params->get('tooltipleft', 0 ) );
$settings['tooltiptop']			= intval($params->get('tooltiptop', 0 ) );
$settings['tooltipwidth']		= trim($params->get('tooltipwidth', '240px' ));
$settings['tooltipcustomcode']	= trim($params->get('tooltipcustomcode'));
//PMS System link
$settings['pmssystem']		    = trim($params->get( 'pmssystem'));
$settings['pmslink']      		= intval($params->get( 'pmslink'));
$settings['pmslinktext'] 		= trim($params->get('pmslinktext','send message'));
//View profile link
$settings['viewprofilelink'] 	= intval($params->get( 'viewprofilelink'));
$settings['viewprofilelinktext']= trim($params->get('viewprofilelinktext','view user profile'));
//Fijiwebdesign's AjaxChat Link
$settings['ajaxchatlink'] 		= intval($params->get('ajaxchatlink'));
$settings['ajaxchatlinktext']	= trim($params->get('ajaxchatlinktext','start private chat'));
// ---- cb support specific ----
$settings['gendersupport']   	= intval($params->get( 'gendersupport'));
$settings['cbgenderfield']   	= trim($params->get('cbgenderfield','cb_gender'));
if($settings['cbsupport'] 		= intval($params->get('cbsupport'))) {
	//Nant's User Gallery integration
	$settings['nantscbgallery']    		 = intval($params->get( 'nantscbgallery'));
	$settings['nantscbgallerylinktext']  = trim($params->get('nantscbgallerylinktext','user has %n additional images'));

	$settings['cbnamefield'] 	= trim($params->get('cbnamefield','cb_firstname'));
	$settings['cbuseavatar']    = intval($params->get( 'cbuseavatar'));
	$settings['cbfemalevalue']  = trim($params->get( 'cbfemalevalue'));
	$settings['cbmalevalue']	= trim($params->get('cbmalevalue'));
	$settings['usergendersort']	= trim($params->get('usergendersort'));
	// cb custom fields
	for ($fieldnum=1;$fieldnum<6; $fieldnum++) {
		$fieldvalue = trim( $params->get('field'.$fieldnum) );
		if ($fieldvalue) {
			$settings['cbcustomfields'][] = trim( $params->get( 'field'.$fieldnum ) );
			$settings['cbfieldimages'][]  = trim( $params->get( 'image'.$fieldnum ) );
			}
		}	
	//Check if a specific CommunityBuilder language file is installed otherwise use the default language
	$settings['cb_language'] = (is_dir($settings['basedir'].'/components/com_comprofiler/plugin/language/'.$settings['language'].'/images')) ? $settings['language'] : 'default_language'; 
	}
// ----- end cb support specific ----

//Convert name setting to appropiate database field
switch ($settings['nametype']) {
	case 'username':
		$settings['namefield'] = 'username';
		break;
	case 'name':
		$settings['namefield'] = 'name';
		break;
	case 'cbfield':
		//If CB Support is off default to username
		$settings['namefield'] = ($settings['cbsupport']) ? $settings['cbnamefield'] : 'username';
		break;
		} 

//########## Database code ###########
//Prepare query according to module parameters
$query = "SELECT a.session_id, a.username, a.guest, a.userid as uid,a.usertype AS type ";
$query .=  ($settings['nametype'] == 'name') ? ", b.name" : "";
if ($settings['cbsupport']) {
	$query .= ($settings['nametype'] == 'cbfield') ? ", c.". $settings['cbnamefield'] : "";
	$query .= ($settings['cbuseavatar']) ? ", c.avatar" : "";
	$query .= ($settings['gendersupport']) ? ", c.".$settings['cbgenderfield'] : "";
	$query .= (isset($settings['cbcustomfields'][0])) ? ", c.". implode(', c.',$settings['cbcustomfields']) : "";
	$query .= ($settings['nantscbgallery'] ) ? ", c.cb_pgtotalitems as imagecount" : "";
	}
$query .= "\n FROM #__session AS a";
$query .=  ($settings['cbsupport']) ? "\n LEFT JOIN #__comprofiler AS c ON (a.userid = c.user_id)" : "";
//If name needed query the user table
$query .= ($settings['nametype']=='name') ? "\n LEFT JOIN #__users AS b ON (a.userid = b.id)":"";
$query .= " ORDER BY username";
//Perform query and load data
$database->setQuery($query);
$rows = $database->loadObjectList();
//Give back a nice error message if query wasn't sucessfull
if ($database->_errorNum) return $content = $liveUsersPro->errorHandler($settings, $database->_errorMsg);

//########## Prepare pre and post tags for the user list according module parameters #########
//Add the sellected theme css to code
if ($settings['theme']) $ul_pre = '<link rel="stylesheet" href="'. $settings['lvu_web']. '/themes/'. $settings['theme'] .'.css" type="text/css"/>
	';	

//Add tooltip if enabled
if ($settings['showtooltip'] and ($my->id or $settings['tooltipshowguest'])) {
	//Generate tooltip template 
	$tooltipScript = $liveUsersPro->createTooltip($settings);
	}
	
// Add additional div scrollbox if scrolling is enabled	
$ul_post = "";
if ($settings['scrolling']) {
	$ul_pre .= '<div id="lvu_scrollbox" style="border: none; overflow-x:hidden; overflow-y:scroll; width:'.$settings['modulewidth'].'; height:' . $settings['moduleheight'] .'">
';
	$ul_post = '</div>
';
}	
$ul_pre .= '<ul id="lvu_userlist" style="width:'.$settings['modulewidth'].';">
';
$ul_post = '</ul>'.$ul_post;

// ############### Generate the correct user list link template according to user list link parameter #####################
switch ($settings['userlistlink']) {
	case 'pms':
		$tagOpen='<a href="[pmslink]"';
		$tagClose='</a>';
		break;
	case 'profile':
		$tagOpen='<a href="[profilelink]"';
		$tagClose='</a>';
		break;
	case 'email':
		$tagOpen='<a href="'. sefRelToAbs('index.php?option=com_comprofiler&task=emailUser&uid=[uid]') .'"';
		$tagClose='</a>';
		break;
	case 'chat':
		$tagOpen='<a href="#" onclick="privateChat(\''.$name.'\');return false;"';
		$tagClose='</a>';
	case 'custom':
		$tagOpen=trim($params->get('userlistlinkcustomcodepre'));
		$tagClose=trim($params->get('userlistlinkcustomcodepost'));
		break;
	default:
		$tagOpen='<a href="#"';
		$tagClose='</a>';
		break;
	}
//Assemble complete user list link template
$link = '<li class="lvu_userlist" name="[name]" gender="[gender]">' . $tagOpen .' class="[gender][type]" id="user[uid]" '.$tooltipScript .'>[name]'. $tagClose . '</li>
';
//########## Start populating list ##########
$guestcount = 0;
$membercount = 0;
$gender = "";
$tagArray = array('[uid]',
				'[username]',
				'[name]',
				'[avatar]',
				'[gender]',
				'[gendertext]',
				'[type]',
				'[nantscbgallerylink]',
				'[cbcustomfields]',
				'[profilelink]',
				'[pmslink]');
if (isset($row->$settings['cbgenderfield'])) {
	$gendertext = &$row->$settings['cbgenderfield'];
	} else {
	$gendertext = '';
	}
if (count($rows) > 0) {

	foreach($rows as $row) {
		//Exclude guests and count them
		if ($row->guest) {
			if ($row->type == '') $guestcount++;
		} else {
			$membercount++;
			//Convert gender values
		   	if (isset($row->$settings['cbgenderfield'])) 
				$gender = ($row->$settings['cbgenderfield'] == $settings['cbfemalevalue']) ? 'female' : 'male';
			//Convert type values
			$row->type = str_replace(' ','_',$row->type);
			// Create content
			if (isset($row->imagecount) == false) $row->imagecount=0;
			$content .= str_replace($tagArray, 
				array(
					$row->uid,
					 $row->username,
					 $row->$settings['namefield'],
					 $liveUsersPro->avatarURL($row->avatar,$settings['cb_language']),
					 $gender,
					 $gendertext,
					 $row->type,
					 $liveUsersPro->nantsCbGalleryLink($settings['nantscbgallerylinktext'], $row->uid, $row->imagecount),
					 $liveUsersPro->cbCustomFields($settings['cbcustomfields'],$settings['cbfieldimages'],$settings['lvu_web'], $row),
					 $liveUsersPro->profileLink($settings['cbsupport'], $row->uid,$row->username),
					 $liveUsersPro->pmsLink($settings['pmssystem'], $row->uid,$row->username) 
				),
				$link);
			}			
		} 
	}

//########## Final code assembly ##########
//Add genderselect field
$sortform = ($settings['usergendersort']) ? '<div id="lvu_genderselect">
'._LVU_GENDERSELECT .'
<select id="lvu_genderselectfield" " onchange="lvu_genderFilter(this.value);" class="inputbox">
	<option value="all">'._LVU_ALL.'</option>
	<option value="male">'. $settings['cbmalevalue'] .'</option>
	<option value="female" >'. $settings['cbfemalevalue'] .'</option>
</select>
</div>' : '';
//Assemble pre code, content and post code or show empty list message
if ($content == '') {
	$content .= $settings['header'].$settings['nousermsg'];
} else {
	$content = $settings['header'].$sortform.$ul_pre.$content.$ul_post;	
}
//Add guest & member count
if ($settings['guestcount']) {
	if($guestcount) $content .= '<div id="lvu_guestcount">'. _LVU_GUESTS  . $guestcount .'</div>';
	if($membercount) $content .='<div id="lvu_membercount">'.  _LVU_MEMBERS  . $membercount . '</div>';
	}
//Add sponsorlink
if ($settings['sponsorlink']) $content .= '<p class="small"><a href="http://www.ndwdesign.net">NDWDesign.net - Joomla Developement</a></p>
';
//Include JavaScript
$content .= '<script type="text/javascript" src="'.$settings['lvu_web'].'/js/liveUsersPro.js"></script>';

//########## Store cache if caching is enabeld ##########
if($settings['cache']) $lvuCache->save($content,$cacheSettings['id']);

//########## Done :-) ##########
return $content;
?>